<?php

include_once("htmlfuncs.php");
include_once("gxml.php");
include_once("search.php");
include_once("logger.php");
include_once("body.php");
include_once(SmartyClass());

function GetPurchaseURL($Associate, $ID, $Cart, $Hmac)
{
  $Filename = "http://xml.amazon.com/onca/xml3?ShoppingCart=get&f=xml&dev-t=D11PEK22YBCZS3&t=$Associate&CartId=$Cart&Hmac=$Hmac";
  
  return $Filename;
}

function AddToNewCart($Associate, $ASIN)
{
  //Add the item to a new Amazon Cart and save the return xml.
  $Filename = "http://xml.amazon.com/onca/xml3?ShoppingCart=add&f=xml&dev-t=D11PEK22YBCZS3&t=$Associate&Asin.$ASIN=1";
  $Obj = GXMLTree($Filename);
 
  //Parse the xml and get the CartID  
  $CartID      = $Obj->SHOPPINGCARTRESPONSE[0]->SHOPPINGCART[0]->CARTID[0]->Data;
  $HMAC        = $Obj->SHOPPINGCARTRESPONSE[0]->SHOPPINGCART[0]->HMAC[0]->Data;
  $PurchaseURL = $Obj->SHOPPINGCARTRESPONSE[0]->SHOPPINGCART[0]->PURCHASEURL[0]->Data;
  
  //Save the cart id to a cookie.
  setcookie("HMAC", urlencode($HMAC), time()+3600);
  setcookie("PURCHASEURL", urlencode($PurchaseURL), time()+3600);
  setcookie("CARTID", urlencode($CartID), time()+3600);

  return $PurchaseURL;  
}

function AddToExistingCart($Associate, $ASIN, $CartID, $HMAC)
{
  //Add the item to an existing cart Amazon Cart and save the return xml.     
  $Filename = "http://xml.amazon.com/onca/xml3?ShoppingCart=add&f=xml&dev-t=D11PEK22YBCZS3&t=$Associate&Asin.$ASIN=1&CartId=$CartID&Hmac=".urldecode($HMAC);
  //$Filename = "http://xml.amazon.com/onca/xml3?ShoppingCart=add&f=xml&dev-t=D11PEK22YBCZS3&t=$Associate&Asin.$ASIN=1&CartId=$CartID&Hmac=".$HMAC;
  $Obj = GXMLTree($Filename);

  //Don't need to retrieve the cart id it is already set in a cookie.
  $PurchaseURL = $Obj->SHOPPINGCARTRESPONSE[0]->SHOPPINGCART[0]->PURCHASEURL[0]->Data;

  if ($PurchaseURL == "")
  {
    $PurchaseURL =  GetPurchaseURL($Associate, $ASIN, $CartID, $HMAC);
  }

  setcookie("PURCHASEURL", urlencode($PurchaseURL), time()+3600);

  return $PurchaseURL;
}

function AddToCart($Associate, $ASIN, $CartID, $HMAC)
{
  //Add $ASIN to Log.
  LogT("C", $ASIN);
  
  $Result = "";
  if ($CartID == "" || $CartID == "0")
  {
    $Result = AddToNewCart($Associate, $ASIN);
  }
  else
  {   
    $Result = AddToExistingCart($Associate, $ASIN, $CartID, $HMAC);
  }
  return $Result;
}

//Get the search word.
  $Associate  = GetParam('Associate', 'thinkbling-20');
  $Category   = GetParam("Category", "books");
  $Keywords   = GetParam("Keywords", "");
  $ASIN       = GetParam("ASIN", "B00000JH6U");
  $Page       = GetParam("Page", "1");
  $CartID     = GetParam("CartID", "");//CARTID and HMAC are only passed as cookies
  $HMAC       = GetParam("HMAC", "");//CARTID and HMAC are only passed as cookies
  $SearchType = GetParam("SearchType", "Keyword");
  $Node       = GetParam("Node", "Keyword");  
  $Sort       = GetParam("Sort", "+salesrank");
  
  if ($ASIN != "")
  {
    $PurchaseURL = AddToCart($Associate, $ASIN, $CartID, $HMAC);
  }
  
  //Create template object.
  $ResultsTemplate = new Smarty;
  $ResultsTemplate->compile_dir = FullSmartyCompileDir();
  
  $Result  = search($Associate, $Category, $Keywords, $Sort);
  $Result .= $ResultsTemplate->fetch('templates'.DirDelimiter().'cart.tpl.htm');
  $Result .= body($Associate, $Category, $Keywords, $Page, $Sort, $CartID, $HMAC, $SearchType, 1, 1, $Node);
  
  include("header.php");
  echo $Result;
  include("footer.php");
?>
