<?php
  include_once ("meta.php");  
  include_once ("search.php");
  include_once ("htmlfuncs.php");
  include_once ("gxml.php");
  include_once ("background.php");
  include_once ("logger.php");
  include_once ("thirdparty.php");
  include_once(SmartyClass());
  
  function get_contents($f)
  {    
    ob_start();
    $retval = @readfile($f);
    if (false !== $retval)
    { // no readfile error
        $retval = ob_get_contents();
    }
    ob_end_clean();
    return $retval;
  }
  
  function GetDescLink($ASIN, $Associate)
  {
    return PopUp("desc.php?Asin=".$ASIN."&Associate=".$Associate,
                 "Description",
                 400,
                 400,
                 "<img src=\"/tbimages/desc.jpg\" border=0>");        
  }
  
  function GetReviewLink($ASIN, $Associate, $Obj)
  {
    $Result = "";
    if (isset($Obj->PRODUCTINFO[0]->DETAILS[0]->REVIEWS[0]->CUSTOMERREVIEW[0]->COMMENT[0]->Data))
    {
      $Result = "review.php?Asin=".$ASIN."&Associate=".$Associate;
    }
    return $Result;
  }
  
  function GetAddLink($ASIN, $Associate, $Obj)
  {    
    $Result = "";
    //If the item is not available.
    $Availability = strtoupper($Obj->PRODUCTINFO[0]->DETAILS[0]->AVAILABILITY[0]->Data);
    if (substr_count($Availability, "NOT AVAILABLE") ||
        substr_count($Availability, "NOT STOCK")     ||
        substr_count($Availability, "DISCONTINUE"))
    {
      $Result = $Obj->PRODUCTINFO[0]->DETAILS[0]->AVAILABILITY[0]->Data;
    }
    else
    {
      if ($Obj->PRODUCTINFO[0]->DETAILS[0]->OURPRICE[0]->Data != "")
      {
        $Result = "cart.php?Associate=$Associate&ASIN=$ASIN";
      }
    }
    return $Result;
  }
  
  function GetRelistLink($Page, $Keywords, $Associate, $Category)
  {
    $KeyWordsClause = "";
    if ($KeyWords != "")
    {
      if (StaticLinks())
      { 
        $KeyWordsClause = "_Keywords_$Keywords";
      }
      else
      {
        $KeyWordsClause = "&Keywords=$Keywords";
      }
    }
    
    if (StaticLinks())
    {
      return "list_Page_".$Page.$KeywordsClause."_Associate_".$Associate."_Category_".$Category.".htm";
    }
    else
    {
      return "list.php?Page=$Page".$KeywordsClause."&Associate=$Associate&Category=$Category";
    }
  }
 
  function GetBuyNowLink($ASIN, $Associate, $Obj)
  {
   $Result = "";
    //If the item is not available.
    $Availability = strtoupper($Obj->PRODUCTINFO[0]->DETAILS[0]->AVAILABILITY[0]->Data);
    if (substr_count($Availability, "NOT AVAILABLE") ||
        substr_count($Availability, "NOT STOCK")     ||
        substr_count($Availability, "DISCONTINUE"))
    {
      $Result = "";//Not available
    }
    else
    {      
      $Result = "http://buybox.amazon.com/o/dt/assoc/handle-buy-box=$ASIN";
    }
    return $Result;
  }

  
  function GetListPriceText($Obj)
  {
    $Result = "";
    if (isset($Obj->PRODUCTINFO[0]->DETAILS[0]->LISTPRICE[0]->Data))
    {
      $Result = $Obj->PRODUCTINFO[0]->DETAILS[0]->LISTPRICE[0]->Data;
    }
    return $Result;
  }
  
  function GetPriceText($Obj)
  {
    $Result = "";
    if (isset($Obj->PRODUCTINFO[0]->DETAILS[0]->OURPRICE[0]->Data))
    {
      $Result = $Obj->PRODUCTINFO[0]->DETAILS[0]->OURPRICE[0]->Data;
    }
    return $Result;
  }

  function GetSavingsText($Obj)
  {
    $Result = "";
    if (isset($Obj->PRODUCTINFO[0]->DETAILS[0]->LISTPRICE[0]->Data) &&
        isset($Obj->PRODUCTINFO[0]->DETAILS[0]->OURPRICE[0]->Data))
    {
      $List   = substr_replace($Obj->PRODUCTINFO[0]->DETAILS[0]->LISTPRICE[0]->Data, "", 0, 1);
      $Our    = substr_replace($Obj->PRODUCTINFO[0]->DETAILS[0]->OURPRICE[0]->Data, "", 0, 1);
      $SaveD  = $List - $Our;
      $SaveP  = round($SaveD / $List * 100);      
      $Result = "$".number_format($SaveD, 2)." (".$SaveP."%)</b>";
    }
    return $Result;
  }  
  
  function GetDesc($Obj)
  {
    $Desc = urldecode($Obj->PRODUCTINFO[0]->DETAILS[0]->PRODUCTDESCRIPTION[0]->Data);
    if (strlen($Desc) > 0)
    {
      $Result = $Desc;//substr($Desc, 0, 250)."...";
    }
    else
    {
      $Result = "No description could be found.";
    }

    return $Result;
  }
    
  function GetUsedPriceLink($ASIN)
  {
    $Result = "";
    if ($UsedPrice != "0")
    {
      if (StaticLinks())
      {
      
      }
      else
      {
        $Result = "detail.php?ASIN=$ASIN&ThirdParty=Used";
      }
    }
    return $Result;
  }
  
  function GetNewPriceLink($ASIN)
  {
    $Result = "";
    if ($NewPrice != "0")
    {
      if (StaticLinks())
      {
      
      }
      else
      {
        $Result .= "detail.php?ASIN=$ASIN&ThirdParty=ThirdPartyNew";
      }
    }
    return $Result;
  }

  function ImgPrice($Obj, $Associate, $ASIN)
  {
    //Get the Used and ThirdParty Prices.
    $UsedPrice = UsedPrice($Associate, $ASIN);
    $NewPrice  = NewPrice($Associate, $ASIN);

    $img     = $Obj->PRODUCTINFO[0]->DETAILS[0]->IMAGEURLMEDIUM[0]->Data;
    $Result  = TRTDC(hreft(Img($img),
                           $Obj->PRODUCTINFO[0]->DETAILS[0]->IMAGEURLLARGE[0]->Data,
                           "NewWindow"));
    $Result .= TRTDC(Font("Arial", "1", "Click on Image for larger view", 0));
    $Result .= TRTDC(GetListPriceText($Obj));
    $Result .= TRTDC(GetPriceText($Obj));
    $Result .= TRTDC(GetSavingsText($Obj));
    $Result .= GetUsedPriceLink($UsedPrice, $Associate, $ASIN);
    $Result .= GetNewPriceLink($NewPrice, $Associate, $ASIN);
    
    return $Result;
  }


  //Get the paramenters
  $Associate  = Associate();
  $Category   = GetParam("Category", "books");
  $Keywords   = GetParam("Keywords", "harry%20potter");
  $Page       = GetParam("Page", "1");
  $ASIN       = GetParam("ASIN", "B00000JH6U");
  $CartID     = GetParam("CartID", "");//CARTID and HMAC are only passed as cookies
  $HMAC       = GetParam("HMAC", "");//CARTID and HMAC are only passed as cookies
  $Sort       = GetParam("Sort", "+salesrank");
  $ThirdParty = GetParam("ThirdParty", "");
  
  //Log the ASIN that is being looked at.
  LogT("I", $ASIN);
  
  $Filename  = "http://xml.amazon.com/onca/xml3?t=$Associate&dev-t=D11PEK22YBCZS3&AsinSearch=$ASIN&type=heavy&f=xml";
  $Obj       = GXMLTree($Filename);
  
  $Title = $Obj->PRODUCTINFO[0]->DETAILS[0]->PRODUCTNAME[0]->Data;

  $MetaText = Meta(SiteName()." $Title $Category $Keywords $ASIN", "$Title $Category $Keywords $ASIN");
  
  //Include addtional information if a file of form $ASIN."d.htm" exists.
  if (file_exists("./additional/".$ASIN."d.htm"))
  {
    $Result .= get_file_contents("./additional/".$ASIN."d.htm");
  }
    
  $ImageSrc     = $Obj->PRODUCTINFO[0]->DETAILS[0]->IMAGEURLMEDIUM[0]->Data;
  $ImageLink    = $Obj->PRODUCTINFO[0]->DETAILS[0]->IMAGEURLLARGE[0]->Data;
  $ListPrice    = GetListPriceText($Obj);
  $OurPrice     = GetPriceText($Obj);
  $Savings      = GetSavingsText($Obj);
  $ThirdPrice   = NewPrice($Associate, $ASIN);
  $ThirdLink    = GetNewPriceLink($ASIN);  
  $UsedPrice    = UsedPrice($Associate, $ASIN);
  $UsedLink     = GetUsedPriceLink($ASIN);
  $Detail       = GetDesc($Obj);
  $BuyNowLink   = GetBuyNowLink($ASIN, $Associate, $Obj);
  $ReviewLink   = GetReviewLink($ASIN, $Associate, $Obj);
  $AddLink      = GetAddLink($ASIN, $Associate, $Obj);
  $FindMoreLink = GetRelistLink($Page, $Keywords, $Associate, $Category);
  
  //Create template object.
  $ResultsTemplate = new Smarty;
  $ResultsTemplate->compile_dir = FullSmartyCompileDir();
  
  $ResultsTemplate->Assign('MetaText',     $MetaText);
  $ResultsTemplate->Assign('ASIN',         $ASIN);
  $ResultsTemplate->Assign('Title',        $Title);
  $ResultsTemplate->Assign('ImageLink',    $ImageLink);
  $ResultsTemplate->Assign('ImageSrc',     $ImageSrc);
  $ResultsTemplate->Assign('ListPrice',    $ListPrice);
  $ResultsTemplate->Assign('OurPrice',     $OurPrice);
  $ResultsTemplate->Assign('Savings',      $Savings);
  $ResultsTemplate->Assign('ThirdPrice',   $ThirdPrice);
  $ResultsTemplate->Assign('ThirdLink',    $ThirdLink);
  $ResultsTemplate->Assign('UsedPrice',    $UsedPrice);
  $ResultsTemplate->Assign('UsedLink',     $UsedLink);
  $ResultsTemplate->Assign('Detail',       $Detail);
  $ResultsTemplate->Assign('BuyNowLink',   $BuyNowLink);
  $ResultsTemplate->Assign('ReviewLink',   $ReviewLink);
  $ResultsTemplate->Assign('AddLink',      $AddLink);
  $ResultsTemplate->Assign('FindMoreLink', $FindMoreLink);

  $Result = search($Associate,
                    $Category,
                    $Keywords,
                    $Sort);

  $Result.=$ResultsTemplate->fetch('templates'.DirDelimiter().'detail.tpl.htm');  

  //Include 3rd party information if it has been selected.
  if ($ThirdParty != "")
  {
    $Result .= ThirdPartyItems($ThirdParty);
  }
  ThirdPartyItems($ThirdParty);
  
  include("header.php");
  echo $Result;
  include("footer.php");
?>


